# This file was generated by symflow CLI vSYM_TEMPLATE_VAR_SYMFLOW_VERSION on SYM_TEMPLATE_VAR_GENERATION_TIME UTC.
# No changes to this file are required to start managing your AWS SSO access with Sym.
# Modify this file to customize your AWS SSO access management, or add more AWS SSO Permission Sets and
# AWS SSO Groups to be managed.

SYM_TEMPLATE_VAR_AWS_SSO_TARGETS

# The Strategy your Flow uses to either:
#   - Create Account Assignments for combinations of AWS SSO Permission Sets and accounts.
#   - Add Users to AWS SSO Groups.
resource "sym_strategy" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_aws_sso" {
  type           = "aws_sso"
  name           = "SYM_TEMPLATE_VAR_FLOW_NAME-aws-sso-strategy"
  integration_id = sym_integration.aws_sso_context.id

  # This must be a list containing `aws_sso_permission_set` and/or `aws_sso_group` sym_targets that users
  # can request to be escalated to
  targets = [SYM_TEMPLATE_VAR_AWS_SSO_SYM_TARGET_IDS]

  settings = {
    # data.aws_ssoadmin_instances.this is defined in connectors.tf
    instance_arn = one(data.aws_ssoadmin_instances.this.arns)
  }
}

resource "sym_flow" "SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_aws_sso" {
  name  = "SYM_TEMPLATE_VAR_FLOW_NAME-aws-sso"
  label = "AWS SSO Access"

  implementation = file("${path.module}/impls/aws_sso_SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_impl.py")
  environment_id = sym_environment.this.id

  params {
    # By specifying a strategy, this Flow will now be able to manage access (escalate/de-escalate)
    # to the targets specified in the `sym_strategy` resource.
    strategy_id = sym_strategy.SYM_TEMPLATE_VAR_FLOW_RESOURCE_NAME_aws_sso.id

    # Each prompt_field defines a custom form field for the Slack modal that
    # requesters fill out to make their requests.
    prompt_field {
      name     = "reason"
      label    = "Why do you need access?"
      type     = "string"
      required = true
    }

    prompt_field {
      name           = "duration"
      type           = "duration"
      allowed_values = ["30m", "1h"]
      required       = true
    }
  }
}
